
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>理解jsp模式2架构：MVC设计模式探险 / iVAN</title>

    <meta name="description" content="理解jsp模式2架构：MVC设计模式探险 js|架构|设计 摘要:通过开发一个熟悉的基于web的购物店,你将学到如何工具化mvc设计模式并且真正地在使用jsp的时候分离内容和表现.Govind Seshadri 会向你展示这是多么的容易(2000字(原文字数)). 尽管相对抛开最近的相关介绍而言,jsp技术正在很好地以自己的方式成为卓越的创建提供动态web内容的应用程序的java技术.java开发者因为许多不同的理由喜爱jsp.一些人喜欢它给交互式web页面带来了&quot;一次编写,到处运行&quot;的变化这个事实:另一些人欣赏它易 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">理解jsp模式2架构：MVC设计模式探险</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>js|架构|设计</p>
<p>　　摘要：通过开发一个熟悉的基于web的购物店，你将学到如何工具化mvc设计模式并且真正地在使用jsp的时候分离内容和表现。Govind Seshadri 会向你展示这是多么的容易(2000字(原文字数))。</p>
<p>　　尽管相对抛开最近的相关介绍而言，jsp技术正在很好地以自己的方式成为卓越的创建提供动态web内容的应用程序的java技术。java开发者因为许多不同的理由喜爱jsp。一些人喜欢它给交互式web页面带来了“一次编写，到处运行”的变化这个事实；另一些人欣赏它易学易用并且帮助人们把java作为服务器端脚本使用。但是都公认一件事——使用jsp最大的好处是能够有效地分离内容与表现。在这篇文章里，我来提供一个深入的看法，关于如何使用jsp模式2架构获得最佳的内容与表现的分离。这个模式也可以被看作流行的mvc设计模式在服务端的实现。请注意在开始之前你应该熟悉jsp和servlet编程，因为我不会在这篇文章中讨论语法问题。</p>
<p><strong>　　那么，servlet有什么问题？<br /></strong></p>
<p>　　既然jsp用来提供动态web内容并且对于从表现层中分离内容很不错，一些人也许想知道为什么servlet要从jsp中脱离出来与它并列。servlet的功用没有问题。它对于服务端处理干得很好，而且，由于它重要的已安装基础，就适合这个。实际上，从结构上说，你可以把jsp看作实现为servlet 2.1 api的扩展的servlet高级抽象。仍然不应该不加区别地使用servlet；它可能不会适用于每一个人。举个例子来说，尽管页面设计者能够很容易地使用常规html或者xml工具编写jsp页面，而servlet通常更适合后台开发者，他们通常使用某种IDE——一个通常需要高层次的编程专门知识的过程。当发布servlet时，即使开发者也必须留意和确认在内容和表现之间没有紧耦合。通常，你可以通过加入第三方的html封装包比如htmlkona来做这个。即使这样做了，尽管带来了一些简单的对于屏幕变化的伸缩性，仍然不能为你防止免受表现格式自身的变化的影响。例如，如果你的表现形式从html转变到dhtml，你将仍然需要确认你的封装包是否兼容这种新格式。在最坏的情况下，如果封装包不能用了，你可能最终会在动态内容内部硬编码表现形式。那么，解决办法是什么？就像你你将要看到的，一个办法将会同时使用jsp和servlet来创建应用系统。</p>
<p><strong>　　差异哲学<br /></strong></p>
<p>　　早期的jsp规范主张两种使用jsp技术创建应用的哲学思路。这两种思路，用术语来说就是jsp模式1和模式2，本质上的区别在于大部分请求的处理发生的位置。在模式1架构中，如图1所示，jsp页面独立地负责处理请求和发送反馈给客户端。这里仍然有内容和表现的分离，因为所有的数据访问是使用bean完成的。尽管模式1架构应该很适合简单应用，但是对于复杂的实现是不可取的。这种结构的任意使用通常会导致大量的脚本和java代码嵌入到jsp页面中，特别是在有大量的请求需要处理的情况下。尽管这可能对java开发者来说不是一个大问题，但是却无疑是一个问题，如果你的jsp页面是由设计师创建和维护的话——在大项目中通常如此。最终，这个问题甚至会导致角色定义和责任分配的混乱，引起本可以轻松避免的项目管理的麻烦。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjAwNzc3MTIxMTUyODMwLmdpZg==.jpg"></p>
<p>图1：jsp模式1结构</p>
<p>　　模式2架构如图2所示，是一个为动态内容服务的混合方案，因为它同时使用了servlet和jsp。它利用了两种技术的优势，使用jsp产生表现层而servlet负责执行敏感任务。在这里，servlet扮演控制器的角色，负责请求处理和产生jsp要使用的bean和对象，以及根据客户的动作决定下一步转发到哪一个jsp页面。特别要注意的是jsp页面内部并没有处理逻辑；它只是简单地负责取得可能是servelet事先创建的对象和bean，并为在了静态模版中插入从servlet释放出动态内容。我的观点是，这个办法一般会形成最干净彻底的表现与内容的分离，使得你的开发团队里的开发者和页面设计师的角色与责任能够清晰。实际上，你的应用越复杂，使用模式2带来的好处就越多。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjAwNzc3MTIxMTUyMzA3LmdpZg==.jpg"></p>
<p>图2：jsp模式2结构</p>
<p>　　为了弄清模式2背后的概念，我们来参观一个细化的具体实现：一个叫做音乐无界的在线音乐商店样品。</p>
<p>　　<strong>了解音乐无界</strong></p>
<p>　　主视图，或者说表现层，对于我们的音乐无界由jsp页面EShop.jsp产生（见清单1）。你会注意到这个页面几乎仅仅处理这个应用的主要用户界面，而且没有做任何处理工作——一个最佳的jsp脚本。也注意一下另一个jsp页面，cart.jsp（见清单2），通过指令&lt;jsp:include page="Cart.jsp" flush="true" /&gt;包含在EShop.jsp之内。</p>
<table>
<tr>
<td>
<br /><strong>清单1</strong></p>
<p><strong>EShop.jsp</strong></p>
</td>
</tr>
<tr>
<td>&lt;%@ page session="true" %&gt;<br />&lt;html&gt;<br />&lt;head&gt;<br />&lt;title&gt;Music Without Borders&lt;/title&gt;<br />&lt;/head&gt;<br />&lt;body bgcolor="#33CCFF"&gt;<br />&lt;font face="Times New Roman,Times" size="+3"&gt;<br />  Music Without Borders<br />&lt;/font&gt;<br />&lt;hr&gt;&lt;p&gt;<br />&lt;center&gt;<br />&lt;form name="shoppingForm" <br />   action="/examples/servlet/ShoppingServlet" <br />   method="POST"&gt;<br />&lt;b&gt;CD:&lt;/b&gt; <br />&lt;select name=CD&gt;<br />  &lt;option&gt;Yuan | The Guo Brothers | China | $14.95&lt;/option&gt;<br />  &lt;option&gt;Drums of Passion | Babatunde Olatunji | Nigeria | $16.95&lt;/option&gt;<br />  &lt;option&gt;Kaira | Tounami Diabate| Mali | $16.95&lt;/option&gt;<br />  &lt;option&gt;The Lion is Loose | Eliades Ochoa | Cuba | $13.95&lt;/option&gt;<br />  &lt;option&gt;Dance the Devil Away | Outback | Australia | $14.95&lt;/option&gt;<br />  &lt;option&gt;Record of Changes | Samulnori | Korea | $12.95&lt;/option&gt;<br />  &lt;option&gt;Djelika | Tounami Diabate | Mali | $14.95&lt;/option&gt;<br />  &lt;option&gt;Rapture | Nusrat Fateh Ali Khan | Pakistan | $12.95&lt;/option&gt;<br />  &lt;option&gt;Cesaria Evora | Cesaria Evora | Cape Verde | $16.95&lt;/option&gt;<br />  &lt;option&gt;Ibuki | Kodo | Japan | $13.95&lt;/option&gt;<br />&lt;/select&gt;<br />&lt;b&gt;Quantity: &lt;/b&gt;&lt;input type="text" name="qty" SIZE="3" value=1&gt;<br />&lt;input type="hidden" name="action" value="ADD"&gt;<br />&lt;input type="submit" name="Submit" value="Add to Cart"&gt;<br />&lt;/form&gt;<br />&lt;/center&gt;<br />&lt;p&gt;<br />&lt;jsp:include page="Cart.jsp" flush="true" /&gt;<br />&lt;/body&gt;<br />&lt;/html&gt;</td>
</tr>
</table>
<table>
<tr>
<td>
<br /><strong>清单2</strong></p>
<p><strong>Cart.jsp</strong></p>
</td>
</tr>
<tr>
<td>&lt;%@ page session="true" import="java.util.*, shopping.CD" %&gt;<br />&lt;%<br />Vector buylist = (Vector) session.getValue("shopping.shoppingcart");<br />if (buylist != null &amp;&amp; (buylist.size() &gt; 0)) {<br />%&gt;<br />&lt;center&gt;<br />&lt;table border="0" cellpadding="0" width="100%" bgcolor="#FFFFFF"&gt;<br />&lt;tr&gt;<br />&lt;td&gt;&lt;b&gt;ALBUM&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;&lt;b&gt;ARTIST&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;&lt;b&gt;COUNTRY&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;&lt;b&gt;PRICE&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;&lt;b&gt;QUANTITY&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;&lt;/td&gt;<br />&lt;/tr&gt;<br />&lt;%<br />  for (int index=0; index &lt; buylist.size();index++) {<br />   CD anOrder = (CD) buylist.elementAt(index);<br />%&gt;<br />&lt;tr&gt;<br />  &lt;td&gt;&lt;b&gt;&lt;%= anOrder.getAlbum() %&gt;&lt;/b&gt;&lt;/td&gt;<br />  &lt;td&gt;&lt;b&gt;&lt;%= anOrder.getArtist() %&gt;&lt;/b&gt;&lt;/td&gt;<br />  &lt;td&gt;&lt;b&gt;&lt;%= anOrder.getCountry() %&gt;&lt;/b&gt;&lt;/td&gt;<br />  &lt;td&gt;&lt;b&gt;&lt;%= anOrder.getPrice() %&gt;&lt;/b&gt;&lt;/td&gt;<br />  &lt;td&gt;&lt;b&gt;&lt;%= anOrder.getQuantity() %&gt;&lt;/b&gt;&lt;/td&gt;<br />  &lt;td&gt;<br />   &lt;form name="deleteForm"<br />    action="/examples/servlet/ShoppingServlet"<br />    method="POST"&gt;<br />   &lt;input type="submit" value="Delete"&gt;<br />   &lt;input type="hidden" name= "delindex" value='&lt;%= index %&gt;'&gt;<br />   &lt;input type="hidden" name="action" value="DELETE"&gt;<br />  &lt;/form&gt; <br />      &lt;/td&gt;<br />    &lt;/tr&gt; <br />    &lt;% } %&gt;<br />  &lt;/table&gt;<br />  &lt;p&gt;<br />  &lt;form name="checkoutForm"<br />    action="/examples/servlet/ShoppingServlet"<br />    method="POST"&gt;<br />    &lt;input type="hidden" name="action" value="CHECKOUT"&gt;<br />    &lt;input type="submit" name="Checkout" value="Checkout"&gt;<br />  &lt;/form&gt;<br />  &lt;/center&gt;<br />&lt;% } %&gt;</td>
</tr>
</table>
<p>　　这里，Cart.jsp处理基于session的购物车的表现形式，它指定了我们的MVC结构中的模型。观察Cart.jsp开头这一段脚本：<br />&lt;%<br />  Vector buylist = (Vector) session.getValue("shopping.shoppingcart");<br />  if (buylist != null &amp;&amp; (buylist.size() &gt; 0)) {<br />%&gt;<br />　　基本上，这段脚本从session中提出了购物车。如果购物车为空或者还未创建，它不会显示任何东西；因此，当用户第一次访问的时候，他见到的页面如图3。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjAwNzc3MTIxMTUzODAwLmdpZg==.jpg"><br />图3：音乐无界，主视图</p>
<p>　　如果购物车不是空的，那么已选中的物品会一次一个地从购物车中被提出，像下面的脚本示范的那样：</p>
<p>&lt;%<br />  for (int index=0; index &lt; buylist.size(); index++) {<br />    CD anOrder = (CD) buylist.elementAt(index);<br />%&gt;<br />　　一旦描述物品的变量已创建，它们就简单地被JSP表达式插入到静态HTML模版中去。图4显示了用户已经放了一些东西到购物车里去是的情况。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjAwNzc3MTIxMTUzNzYxLmdpZg==.jpg"><br />图4：音乐无界，购物车视图</p>
<p>　　这里要注意的重要的一件事是对所有动作的处理既不发生在EShop.jsp也不在Cart.jsp里，而是由控制器servlet，ShoppingServlet.java处理，见清单3：</p>
<table>
<tr>
<td>
<br /><strong>清单3</strong></p>
<p><strong>ShoppingServlet.java</strong></p>
</td>
</tr>
<tr>
<td>import java.util.*;<br />import java.io.*;<br />import javax.servlet.*;<br />import javax.servlet.http.*;<br />import shopping.CD;<br />public class ShoppingServlet extends HttpServlet {<br />  public void init(ServletConfig conf) throws ServletException  {<br />    super.init(conf);<br />  }<br />  public void doPost (HttpServletRequest req, HttpServletResponse res)<br />      throws ServletException, IOException {<br />    HttpSession session = req.getSession(false);<br />    if (session == null) {<br />      res.sendRedirect("<u>http://localhost:8080/error.html</u>");<br />    }<br />    Vector buylist=<br />      (Vector)session.getValue("shopping.shoppingcart");<br />    String action = req.getParameter("action");<br />    if (!action.equals("CHECKOUT")) {<br />      if (action.equals("DELETE")) {<br />        String del = req.getParameter("delindex");<br />        int d = (new Integer(del)).intValue();<br />        buylist.removeElementAt(d);<br />      } else if (action.equals("ADD")) {<br />        //any previous buys of same cd?<br />        boolean match=false;<br />        CD aCD = getCD(req);<br />        if (buylist==null) {<br />          //add first cd to the cart<br />          buylist = new Vector(); //first order<br />          buylist.addElement(aCD);<br />        } else { // not first buy<br />          for (int i=0; i&lt; buylist.size(); i++) {<br />            CD cd = (CD) buylist.elementAt(i);<br />            if (cd.getAlbum().equals(aCD.getAlbum())) {<br />              cd.setQuantity(cd.getQuantity()+aCD.getQuantity());<br />              buylist.setElementAt(cd,i);<br />              match = true;<br />            } //end of if name matches<br />          } // end of for<br />          if (!match) <br />            buylist.addElement(aCD);<br />        }<br />      }<br />      session.putValue("shopping.shoppingcart", buylist);<br />      String url="/jsp/shopping/EShop.jsp";<br />      ServletContext sc = getServletContext();<br />      RequestDispatcher rd = sc.getRequestDispatcher(url);<br />      rd.forward(req, res);<br />    } else if (action.equals("CHECKOUT"))  {<br />      float total =0;<br />      for (int i=0; i&lt; buylist.size();i++) {<br />        CD anOrder = (CD) buylist.elementAt(i);<br />        float price= anOrder.getPrice();<br />        int qty = anOrder.getQuantity();<br />        total += (price * qty);<br />      }<br />      total += 0.005;<br />      String amount = new Float(total).toString();<br />      int n = amount.indexOf('.');<br />      amount = amount.substring(0,n+3);<br />      req.setAttribute("amount",amount);<br />      String url="/jsp/shopping/Checkout.jsp";<br />      ServletContext sc = getServletContext();<br />      RequestDispatcher rd = sc.getRequestDispatcher(url);<br />      rd.forward(req,res);<br />    }<br />  }<br />  private CD getCD(HttpServletRequest req) {<br />    //imagine if all this was in a scriptlet...ugly, eh?<br />    String myCd = req.getParameter("CD");<br />    String qty = req.getParameter("qty");<br />    StringTokenizer t = new StringTokenizer(myCd,"|");<br />    String album= t.nextToken();<br />    String artist = t.nextToken();<br />    String country = t.nextToken();<br />    String price = t.nextToken();<br />    price = price.replace('$',' ').trim();<br />    CD cd = new CD();<br />    cd.setAlbum(album);<br />    cd.setArtist(artist);<br />    cd.setCountry(country);<br />    cd.setPrice((new Float(price)).floatValue());<br />    cd.setQuantity((new Integer(qty)).intValue());<br />    return cd;<br />  }<br />}</td>
</tr>
</table>
<p>　　每次用户在EShop.jsp中添加一件物品，请求都被发送到这个控制器servlet。它依次决定合适的动作，然后处理相应要添加的物品的请求参数。它就实例化一个新的CD bean（见清单4）代表这个选择的物品，接着在把这个bean放进session之前处理购物车的更新。<br />
<table>
<tr>
<td>
<br /><strong>清单4</strong></p>
<p><strong>CD.java</strong></p>
</td>
</tr>
<tr>
<td>package shopping;<br />public class CD {<br />  String album;<br />  String artist;<br />  String country;<br />  float price;<br />  int quantity;<br />  public CD() {<br />    album="";<br />    artist="";<br />    country="";<br />    price=0;<br />    quantity=0;<br />  }<br />  public void setAlbum(String title) {<br />    album=title;<br />  }<br />  public String getAlbum() {<br />    return album;<br />  }<br />  public void setArtist(String group) {<br />    artist=group;<br />  }<br />  public String getArtist() {<br />    return artist;<br />  }<br />  public void setCountry(String cty) {<br />    country=cty;<br />  }<br />  public String getCountry() {<br />    return country;<br />  }<br />  public void setPrice(float p) {<br />    price=p;<br />  }<br />  public float getPrice() {<br />    return price;<br />  }<br />  public void setQuantity(int q) {<br />    quantity=q;<br />  }<br />  public int getQuantity() {<br />    return quantity;<br />  }<br />}</td>
</tr>
</table>
<p>　　注意我们在这个servlet中还包括了额外的智能，因此它能够知道如果选择了一张已在购物车中的CD，那么应该简单地增加session中CD bean的计数。它也处理从Cart.jsp中触发的动作，比如用户从购物车中删除物品，或是继续去收银台结帐。注意控制器总是对哪个资源应该被调用来对特定的动作产生回馈有完全的控制权。例如，对购物车状态的改变，像增加和删除，会引起控制器将请求处理后转发给EShop.jsp页面。这样引起该页面依照已更新的购物车依次重新显示主视图。如果用户决定结帐，则请求被处理后转发给Checkout.jsp（见清单5），通过后面的请求分配器，象下面显示的这样：</p>
<p>String url="/jsp/shopping/Checkout.jsp";<br />ServletContext sc = getServletContext();<br />RequestDispatcher rd = sc.getRequestDispatcher(url);<br />rd.forward(req,res);</p>
<table>
<tr>
<td>
<br /><strong>清单5</strong></p>
<p><strong>Checkout.jsp</strong></p>
</td>
</tr>
<tr>
<td>&lt;%@ page session="true" import="java.util.*, shopping.CD" %&gt;<br />&lt;html&gt;<br />&lt;head&gt;<br />&lt;title&gt;Music Without Borders Checkout&lt;/title&gt;<br />&lt;/head&gt;<br />&lt;body bgcolor="#33CCFF"&gt;<br />&lt;font face="Times New Roman,Times" size=+3&gt;<br />  Music Without Borders Checkout<br />&lt;/font&gt;<br />&lt;hr&gt;&lt;p&gt;<br />&lt;center&gt;<br />&lt;table border="0" cellpadding="0" width="100%" bgcolor="#FFFFFF"&gt;<br />&lt;tr&gt;<br />&lt;td&gt;&lt;b&gt;ALBUM&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;&lt;b&gt;ARTIST&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;&lt;b&gt;COUNTRY&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;&lt;b&gt;PRICE&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;&lt;b&gt;QUANTITY&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;&lt;/td&gt;<br />&lt;/tr&gt;<br />&lt;%<br />  Vector buylist = (Vector) session.getValue("shopping.shoppingcart");<br />  String amount = (String) request.getAttribute("amount");<br />  for (int i=0; i &lt; buylist.size();i++) {<br />   CD anOrder = (CD) buylist.elementAt(i);<br />%&gt;<br />&lt;tr&gt;<br />&lt;td&gt;&lt;b&gt;&lt;%= anOrder.getAlbum() %&gt;&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;&lt;b&gt;&lt;%= anOrder.getArtist() %&gt;&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;&lt;b&gt;&lt;%= anOrder.getCountry() %&gt;&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;&lt;b&gt;&lt;%= anOrder.getPrice() %&gt;&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;&lt;b&gt;&lt;%= anOrder.getQuantity() %&gt;&lt;/b&gt;&lt;/td&gt;<br />&lt;/tr&gt;<br />&lt;%<br />  }<br />  session.invalidate();<br />%&gt;<br />&lt;tr&gt;<br />&lt;td&gt;     &lt;/td&gt;<br />&lt;td&gt;     &lt;/td&gt;<br />&lt;td&gt;&lt;b&gt;TOTAL&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;&lt;b&gt;$&lt;%= amount %&gt;&lt;/b&gt;&lt;/td&gt;<br />&lt;td&gt;     &lt;/td&gt;<br />&lt;/tr&gt;<br />&lt;/table&gt;<br />&lt;p&gt;<br />&lt;a href="/examples/jsp/shopping/EShop.jsp"&gt;Shop some more!&lt;/a&gt;<br />&lt;/center&gt;<br />&lt;/body&gt;<br />&lt;/html&gt;</td>
</tr>
</table>
<p>　　Checkout.jsp仅仅从session中提出购物车并为此请求提取出总金额，然后显示选中的物品和他们的总价格。图5显示了结算时的用户视图。一旦用户去结帐，删除session对象是同样重要的。这个由页面末端的session.invalidate()调用来完成。有两个理由必须这样做。第一，如果没有使session无效，用户的购物车不会重新初始化；如果用户结帐后试图开始新一轮的采购，她的购物车会继续保存着已经付过钱的物品。第二，如果用户结帐后仅仅是离开了网站，这个session对象不会被垃圾收集机制回收而是继续占用宝贵的系统资源直到租约到期。因为缺省的session租约时间是大约三十分钟，在一个大容量系统上这将会很快导致系统内存耗尽。当然，我们都知道对一个耗尽了系统内存的应用程序会发生什么。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjAwNzc3MTIxMTUzNzAzLmdpZg==.jpg"></p>
<p>图5：结账视图</p>
<p>　　注意这个应用所有的资源都是session相关的，因为这里的模式存储在session里。因此，你必须确保用户不会因为某些原因甚至由于错误直接访问控制器。你可以在控制器检测到缺少有效session的时候让客户端自动转向到一个错误页面（见列表6），来避免这种情况的发生。</p>
<table>
<tr>
<td>
<br /><strong>列表6</strong></p>
<p><strong>error.html</strong></p>
</td>
</tr>
<tr>
<td>&lt;html&gt;<br />&lt;body&gt;<br />&lt;h1&gt;<br />  Sorry, there was an unrecoverable error! &lt;br&gt;<br />  Please try &lt;a href="/examples/jsp/shopping/EShop.jsp"&gt;again&lt;/a&gt;.<br />&lt;/h1&gt;<br />&lt;/body&gt;<br />&lt;/html&gt;</td>
</tr>
</table>
<p><strong>　　部署音乐无界</strong></p>
<p>　　我假定你正在使用来自sun的最新版本的JavaServer Web Development Kit (JSWDK)来运行这个例子。如果不是，参看资源小节去看看到哪里取得它。假设服务器安装在\jswdk-1.0.1，这是Microsoft Windows系统下的缺省路径，可以象下面这样部署音乐无界应用：</p>
<p>Create shopping directory under \jswdk-1.0.1\examples\jsp <br />Copy EShop.jsp to \jswdk-1.0.1\examples\jsp\shopping <br />Copy Cart.jsp to \jswdk-1.0.1\examples\jsp\shopping <br />Copy Checkout.jsp to \jswdk-1.0.1\examples\jsp\shopping <br />Compile the .java files by typing javac *.java <br />Copy ShoppingServlet.class to \jswdk-1.0.1\webpages\Web-Inf\servlets <br />Create shopping directory under \jswdk-1.0.1\examples\Web-Inf\jsp\beans <br />Copy CD.class to \jswdk-1.0.1\examples\Web-Inf\jsp\beans\shopping <br />Copy error.html to \jswdk-1.0.1\webpages <br />Once your server has been started, you should be able to access the application using <u>http://localhost:8080/examples/jsp/shopping/EShop.jsp</u> as the URL <br />只要你的服务器启动，你应该可以使用URL <u>http://localhost:8080/examples/jsp/shopping/EShop.jsp</u>来访问这个应用程序。</p>
<p><strong>　　利用jsp和servlet</strong></p>
<p>　　着这个例子里，我们从细节上检查了控制的层次和模式2架构提供的灵活性。实际上，我们已经看到了servlet和jsp页面最好的特性是如何开发出最大化的内容与表现的剥离。只要正确地应用，模式2架构会将所有的处理逻辑集中到控制器servlet手里，而jsp页面只负责视图或者说表现层的工作。然而，使用模式2结构的阻力在于它的复杂性。因此，对于简单应用使用模式1也是可以接受的。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 15:06:17</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e9%a1%b5%e9%9d%a2/" title="页面">页面</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/session/" title="session">session</a>, <a href="https://www.iamivan.net/tag/jsp/" title="jsp">jsp</a>, <a href="https://www.iamivan.net/tag/servlet/" title="servlet">servlet</a>, <a href="https://www.iamivan.net/tag/%e8%b4%ad%e7%89%a9%e8%bd%a6/" title="购物车">购物车</a>, <a href="https://www.iamivan.net/tag/servelet/" title="servelet">servelet</a>, <a href="https://www.iamivan.net/tag/java%e8%b4%ad%e7%89%a9%e8%bd%a6%e9%97%ae%e9%a2%98/" title="java购物车问题">java购物车问题</a>, <a href="https://www.iamivan.net/tag/jsp%e8%b4%ad%e7%89%a9%e8%bd%a6%e5%ae%9e%e4%be%8b/" title="jsp购物车实例">jsp购物车实例</a>, <a href="https://www.iamivan.net/tag/jsp%e5%ae%9e%e7%8e%b0%e8%b4%ad%e7%89%a9%e8%bd%a6/" title="jsp实现购物车">jsp实现购物车</a>, <a href="https://www.iamivan.net/tag/mvc%e8%b4%ad%e7%89%a9%e8%bd%a6/" title="mvc购物车">mvc购物车</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>理解jsp模式2架构：MVC设计模式探险的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/6b3Py0M.html" rel="bookmark">学习顺便翻译：理解jsp模式2架构&mdash;&mdash;MVC设计模式探险</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				js|架构|设计 理解jsp模式2架构 MVC设计模式探险 摘要:通过开发一个熟悉的基于web的购物店,你将学到如何工具化mvc设计模式并且真正地在使用jsp的时候分离内容和表现.Govind Seshadri 会向你展示这是多么的容易(2000字(原文字数)). 作者:Govind Seshadri 尽管相对抛开最近的相关介绍而言,jsp技术正在很好地以自己的方式成为卓越的创建提供动态web内容的应用程序的java技术.java开发者因为许多不同的理由喜爱jsp.一些人喜欢它给交互式web页面			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxPa9yM.html" rel="bookmark">JSP隐式对象和MVC设计模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 今天我们一起来了解一下关于JSP应用的JSP的隐式对像和MVC设计模式. 首先我们先来说一下JSP的隐式对象:JSP隐式对象是Web容器加载的一组类的实例.它是可以直接在JSP页面使用的对象.分为4个主要类别:1. 输入和输出对象:控制页面的输入和输出(request.response.out). 2. 作用域通信对象:检索与JSP页面的Servlet相关的信息(session.application.pageContext). 3. Servlet对象:提供有关页面环境的信息(page.co			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY2rmBp.html" rel="bookmark">设计模式、企业应用架构模式和架构模式学习总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				设计模式: 简单工厂模式 工厂方法模式 抽象工厂方法模式 单例模式 外观模式 生成器模式 原形模式 中介者模式 代理模式 观察者模式 命令模式 迭代器模式 组合模式 模版方法模式 策略模式 状态模式 备忘录模式 享元模式 解释器模式 装饰器模式 职责链模式 桥接模式 访问者模式 企业应用架构模式 事务脚本 大家都懂的写法 领域模型 DDD的建模方法:领域对象.value对象 Unit of Work Entity Framework已经集成这功能了 Lazy Load 同上 查询对象 针对Spe			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba7m5Xp.html" rel="bookmark">sqlserver2005-关于MVC&plus;Jsp模式学生成绩管理系统中src下servlet和bean的设置问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 关于MVC+Jsp模式学生成绩管理系统中src下servlet和bean的设置问题 &lt;%@ page contentType=&quot;text/html; charset=gb2312&quot; language=&quot;java&quot; import=&quot;java.sql.*&quot; %&gt; 无标题文档 /jsp:useBean &lt;% if(stu_id==null){response.sendRedirect(&quot;login.jsp&quot			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxPD7QM.html" rel="bookmark">基于MVC设计模式的WEB应用框架研究</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要 MVC设计模式是基于J2EE的WEB应用开发的首选模式,当前许多流行的框架也都是基于MVC设计模式的.本文简要介绍了MVC设计模式和Struts框架,并提出了一种基于MVC模式的新型WEB应用开发框架--WebFramework,并对该框架的各个层次的组成.功能进行了详细的描述. 关键词 MVC设计模式:J2EE:框架:Struts 引言 随着开源软件的兴起,各种框架也纷纷出现,如Apache 的开源框架Struts就是典型的代表.在实际软件开发中运用这些框架,大大降低了J2EE开发的复杂			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/jbE4G9z.html" rel="bookmark">【转载】理解本真的REST架构风格</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				      本文将带您领略REST架构的起源.与Web的关系.REST架构的本质及特性,以及REST架构与其他架构风格之间的比较. 引子       在移动互联网.云计算迅猛发展的今天,作为一名Web开发者,如果您还没听说过&quot;REST&quot;这个buzzword,显然已经落伍了.夸张点说,甚至&quot;出了门都不好意思跟别人打招呼&quot;.尽管如此,对于REST这个泊来品的理解,大多数人(包括一些资深的架构师)仍然停留在&quot;盲人摸象&quot;的阶段.常常听到各种各样关于RES			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/YMRg4ap.html" rel="bookmark">MVC 设计模式带来更好的软件结构和代码重用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				设计 模型-视图-控制器(MVC)是Xerox PARC在八十年代为编程语言Smalltalk-80发明的一种软件设计模式,至今已被广泛使用.最近几年被推荐为Sun公司J2EE平台的设计模式,并且受到越来越多的使用 ColdFusion 和 PHP 的开发者的欢迎.模型-视图-控制器模式是一个有用的工具箱,它有很多好处,但也有一些缺点. MVC如何工作 MVC是一个设计模式,它强制性的使应用程序的输入.处理和输出分开.使用MVC应用程序被分成三个核心部件:模型.视图.控制器.它们各自处理自己的任			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba7EoPp.html" rel="bookmark">欢迎团队朋友一起创业B2B交易网&comma;需要&colon;ASP&comma;NET&sol;PHP&sol;JSP&sol;SEO&sol;美工&sol;架构人员</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 欢迎团队朋友一起创业B2B交易网,需要:ASP,NET/PHP/JSP/SEO/美工/架构人员希望有工作经验者一起创业,合作方式:技术入股主式..3,系统所需人员大致如下:一)专业Web网站美工要求熟悉DIV+CSS,HTML,XML,尤其要熟悉JavaScript和AJAX.二)软件工程师要求熟悉B/S开发,对面向对象的基本知识要求很熟悉,对常见的设计模式要有一定的认识,譬如,单例模式,工厂模式,门面模式....并能对ADO.NET有深刻的认识.同时要求熟悉数据库的基本知识,能写简单			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0bo11Xp.html" rel="bookmark">ASP&period;NET下MVC设计模式的实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				asp.net|设计 ASP.NET是微软最新推出的新型体系结构.NET框架的一部分,它为构造新一代动态网站和基于网络的分布式应用提供了强有力的支持.与以前的 Web 开发模型相比,ASP.NET 提供了许多重要的优点例如: 简易性:安全性:可管理性等.而且与基于过程的ASP页面技术相比,面向对象技术在ASP.NET中得到了完全实现.用传统ASP技术建立的Web应用实例中,在页面中同时实现显示,业务逻辑和流程控制,这从工程化的角度考虑,它有许多不足之处.用户界面承担着向用户显示问题模型和与用户进			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ1K8b.html" rel="bookmark" class="title">百度地图 js 通过IP定位城市后，已知一个坐标集合，根据每个坐标添加标注点，求大神help me</a>
					<div>
						问题描述 百度地图 js 通过IP定位城市后,已知一个坐标集合,根据每个坐标添加标注点,求大神help me var myCity = new BMap.LocalCity(); // 以当前IP定位 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbaK6np.html" rel="bookmark" class="title">用Visual InterDev规划站点</a>
					<div>
						interdev|visual|规划|站点|interdev|visual 使用Visual InterDev提供的强大工具,你可以专注于设计你的Web功能,而诸如文件管理,连接修改,浏览的细节都可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQvyZM.html" rel="bookmark" class="title">【经验】10种在SEO之外获得网站流量的方式</a>
					<div>
						seo|流量 每个人都希望获得来自搜索引擎的自然的排名(左侧排名),但要掌握搜索引擎排名规则的变化将是一件巨大的工程. 但是,如果你建立了一个以好内容为基础的站点并且按照本篇文章介绍的方法实施,你会获 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9mEgM.html" rel="bookmark" class="title">摆脱SEO菜鸟行列 用心是王道</a>
					<div>
						对于本身SEO初级的人员来讲的话,我们常规会说是一个&quot;菜鸟&quot;,当然,本人不觉得这是一个不好的词或者说一定是强加给这些初学的SEO人员的.事实上,对于菜鸟SEO来讲的话,如何把能力或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqP3kb.html" rel="bookmark" class="title">谈谈友情链接的核心在于网站互换链接、互惠链接</a>
					<div>
						相信大多数站长已经都经历过站点的链接交换这个过程,其中也不乏有一部分站长是靠卖链接盈利,但是大家是否想过这么一个问题:我们的链接交换为什么要被称之为&quot;友情链接&quot;,难道这只是一个单纯 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pL91Az.html" rel="bookmark" class="title">十天学会ASP&period;net之第三天</a>
					<div>
						asp.net 学习目的:掌握WEB控件的使用(一) 或许你会问,为什么需要WEB控件?WEB控间就好像VB里面的控间,可以在程序的任何地方引用,修改所有属性,有了它的配合才能完成代码分离.想一下,如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKqVap.html" rel="bookmark" class="title">C&num;算术操作符和算术表达式</a>
					<div>
						C#中提供的算术操作符有五种: ●+ 加法操作符 ●- 减法操作符 ●* 乘法操作符 ●/ 除法操作符 ●% 求余操作符 在表达式的运算中,表达式总是按它们本身书写的顺序求值,如下例: 程序清单7-1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91aYoM.html" rel="bookmark" class="title">CSS实现兼容性的渐变背景&lpar;gradient&rpar;效果兼容众多浏览器</a>
					<div>
						一.有点俗态的开场白 要是两年前,实现&quot;兼容性的渐变效果&quot;这个说法估计不会被提出来的,那个时 候,说起渐变背景,想到的多半是IE的渐变滤镜,其他浏览器尚未支持,但是,在对CSS3支 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3Kdvp.html" rel="bookmark" class="title">win8安装chrome浏览器失败经常提示错误代码0x80070057如何解决</a>
					<div>
						  win8安装chrome浏览器失败经常提示错误代码0x80070057如何解决 1.删除旧的配置文件,比如C:Documents and SettingsXXXLocal SettingsAppl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3KJZM.html" rel="bookmark" class="title">IE10出现选项卡栏与地址栏重叠</a>
					<div>
						  随着微软通过Windows Updata服务开始向Windows 7用户推送IE10的更新,越来越多的用户选择升级到IE10.这也可以通过数据反馈出来,上月IE10便在全球范围内斩获了1.35%的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJAP2p.html" rel="bookmark" class="title">thttpd服务器概述</a>
					<div>
						  随着微处理器技术.计算机网络技术的进步,基于嵌入式WEB的网络数字视频监控系统逐渐得到了人们的广泛关注.把图像采集.视频压缩和WEB功能集中到一个体积很小的设备内,可以直接连入局域网和Intern ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EQJkM.html" rel="bookmark" class="title">WIN7的IP地址在哪&comma;怎么自定义修改呢？</a>
					<div>
						  第一步.对任务栏的右下角的&quot;网络连接&quot;进行右键选择&quot;打开网络和共享中心&quot;. 第二步.在&quot;网络和共享中心&quot;界面,我们选择&quot;更改适 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYRq6Qp.html" rel="bookmark" class="title">文件夹变扩展名</a>
					<div>
						新建一个文件夹,在后面加上下面任一个扩展名,就会变成相应的文件.  .{00021401-0000-0000-C000-000000000046} 无关联文件 .{871C5380-42A0-1069 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrX3kOz.html" rel="bookmark" class="title">JNDI 的理解</a>
					<div>
						JNDI是 Java 命名与目录接口(Java Naming and Directory Interface),在J2EE规范中是重要的规范之一,不少专家认为,没有透彻理解JNDI的意义和作用,就没有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxY5nPp.html" rel="bookmark" class="title">汇编程序：转圈求和</a>
					<div>
						转圈求和 (1)写程序,对给出的8个数,将相邻的数求和(最后写第一个数与最后一个数的和),并把结果写在其后.在下面的示例中,求和的结果为3 5 7 9 11 13 15 9. datasg segme ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqyejz.html" rel="bookmark" class="title">Swift 3&period;0 新增安全特性的一点普及</a>
					<div>
						本文讲的是Swift 3.0 新增安全特性的一点普及, 在 Swift 发布之后,Swift 的开发者一直在强调,安全性与可选择类型是 Swift 最为重要的特性之一.他们提供了一种nil的表示机制, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeo6mVM.html" rel="bookmark" class="title">（揭秘监控技术）《潜行追踪》：FBI 给你28天，你也逃不掉，中国版呢？</a>
					<div>
						       上周末,雷锋网编辑小李经人推荐,把美版&lt;Hunted:潜行追踪&gt;第一季刷完了. 这部剧为什么这么好看?和网络安全又有什么联系?要想知道这些问题的答案,先来简单介绍一下: &l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mye2EJM.html" rel="bookmark" class="title">什么是Cyclomatic Complexity（圈复杂度）？</a>
					<div>
						  Campwood Software   SourceMonitor Version 3.5 The freeware program SourceMonitor lets you see insi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgY1kM.html" rel="bookmark" class="title">Facebook将要从其主移动应用中移除通讯功能</a>
					<div>
						硅谷网讯 作为一家宣称要连接数十亿人的公司,Facebook却将要使得人们的交流变得更困难.未来几周,Facebook的移动应用将移除聊天功能,此举无疑会给大量活跃用户造成困扰.不过该社交网络的这类行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrqE1vb.html" rel="bookmark" class="title">Codeforces 584 C&period; Marina and Vasya &lpar;Codeforces Round &num;324 &lpar;Div&period; 2&rpar;&rpar;</a>
					<div>
						C. Marina and Vasya time limit per test 1 second memory limit per test 256 megabytes input standard  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYN9gBp.html" rel="bookmark" class="title">js实现控制textarea输入字符串的个数&comma;鼠标按下抬起判断输入字符数&lowbar;javascript技巧</a>
					<div>
						[Html代码] &lt;table&gt; &lt;tr&gt; &lt;td width=&quot;150&quot;&gt;短信内容:&lt;/td&gt; &lt;td&gt; &lt;te ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAkXBAz.html" rel="bookmark" class="title">Mysql select in 按id排序实现方法&lowbar;Mysql</a>
					<div>
						表结构如下: mysql&gt; select * from test; +----+-------+ | id | name | +----+-------+ | 1 | test1 | | 2 | ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0rkxp.html" rel="bookmark" class="title">asp&period;net防止刷新时重复提交&lpar;可禁用工具条刷新按钮&rpar;&lowbar;实用技巧</a>
					<div>
						前段时间遇到了需要禁用刷新的需求,f5按钮就不说了,简单的js就能把它禁用,但是工具条上的刷新按钮却傻傻干不掉. 如果简单的在刷新时重新加载画面,通过window.location.href=&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1gnkb.html" rel="bookmark" class="title">Oracle9i的全文检索技术开发者网络Oracle&lowbar;oracle</a>
					<div>
						正在看的ORACLE教程是:Oracle9i的全文检索技术开发者网络Oracle.介绍:细处着手,巧处用功.高手和菜鸟之间的差别就是:高手什么都知道,菜鸟知道一些.电脑小技巧收集最新奇招高招,让你轻松 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOv6wb.html" rel="bookmark" class="title">scrapy python-为什么我用scrapy抓页面时，&amp;amp&semi;amp&semi;lt&semi;strong&amp;amp&semi;amp&semi;gt&semi;标签里面的字没有？代码如下</a>
					<div>
						问题描述 为什么我用scrapy抓页面时,&lt;strong&gt;标签里面的字没有?代码如下 from scrapy.contrib.spiders import CrawlSpider from ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mqg2jez.html" rel="bookmark" class="title">网上曝&OpenCurlyDoubleQuote;海运女&rdquo;事件 发帖人将承担刑事责任</a>
					<div>
						长宁警方对发帖人朱某以涉嫌侮辱罪立案 记者 王奇芳 周 慧 轰动网络的&quot;海运女&quot;艳照门事件有了最新进展.受害人YH小姐的代理律师前天接受本报记者独家专访时透露,上周四,长宁警方以发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQWNBOp.html" rel="bookmark" class="title">做网站其实贵在坚持 成功将离你不远了</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 不论做什么事,你都要坚持的做下去, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlA98np.html" rel="bookmark" class="title">社交媒体战略传播价值惊人 获美军高层关注</a>
					<div>
						中新网10月22日电&amp;http://www.aliyun.com/zixun/aggregation/37954.html&quot;&gt;nbsp;最新一期&lt;学习时报&gt;发表署名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOW78qz.html" rel="bookmark" class="title">C&num;里windows&period;forms&period;Radiobutton里显示的内容怎么设置换行</a>
					<div>
						问题描述 windows.forms.Radiobutton里显示的内容怎么设置换行,有没有相关属性,谢谢 解决方案 解决方案二:Radiobutton1.Text=&quot;aaaaa&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn4lVZb.html" rel="bookmark" class="title">Xamarin公司开发顾问Nish Anil：移动跨平台已成趋势</a>
					<div>
						2016年6月1日,2016微软开发者峰会在京召开.Xamarin公司开发顾问Nish Anil做主题演讲时说明移动跨平台开发技术的全球趋势,以及重现四月份Xamarin Evolve大会中的最新发布 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
